/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
)

// ServicesQuickbooksStaticApiService ServicesQuickbooksStaticApi service
type ServicesQuickbooksStaticApiService service

type ApiAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest struct {
	ctx                                                               context.Context
	ApiService                                                        *ServicesQuickbooksStaticApiService
	appAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest
}

//
func (r ApiAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest(appAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) ApiAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest {
	r.appAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest = &appAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest
	return r
}

func (r ApiAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) Execute() (*QuickbooksStaticUserAuth, *http.Response, error) {
	return r.ApiService.AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewExecute(r)
}

/*
AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNew Authorize a service

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest
*/
func (a *ServicesQuickbooksStaticApiService) AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNew(ctx context.Context) ApiAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest {
	return ApiAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest{
		ApiService: a,
		ctx:        ctx,
	}
}

// Execute executes the request
//  @return QuickbooksStaticUserAuth
func (a *ServicesQuickbooksStaticApiService) AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewExecute(r ApiAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) (*QuickbooksStaticUserAuth, *http.Response, error) {
	var (
		localVarHTTPMethod  = http.MethodPost
		localVarPostBody    interface{}
		formFiles           []formFile
		localVarReturnValue *QuickbooksStaticUserAuth
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "ServicesQuickbooksStaticApiService.AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNew")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/services/quickbooks_static"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.appAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest == nil {
		return localVarReturnValue, nil, reportError("appAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.appAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
